Imports System.ComponentModel

<ToolboxItem(False)> _
Public Class FaceControlEditorDropdown
    Inherits ListBox

    ' The editor service displaying us.
    Private m_EditorService As IWindowsFormsEditorService

    ' A margin around the image in the list box.
    Private Const ITEM_MARGIN As Integer = 2

    Public Sub New(ByVal face_state As FaceControl.FaceStates, ByVal editor_service As IWindowsFormsEditorService)
        MyBase.New()
        m_EditorService = editor_service

        ' Give the list some items.
        Me.Items.AddRange(New Object() { _
            FaceControl.FaceStates.Happy, _
            FaceControl.FaceStates.Neutral, _
            FaceControl.FaceStates.Sad, _
            FaceControl.FaceStates.Painful _
        })

        Me.SelectedIndex = face_state
        Me.DrawMode = Windows.Forms.DrawMode.OwnerDrawFixed
        Me.ItemHeight = 32 + 2 * ITEM_MARGIN
    End Sub

    ' Close the dropdown.
    Private Sub FaceControlEditorDropdown_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Click
        If m_EditorService IsNot Nothing Then m_EditorService.CloseDropDown()
    End Sub

    ' Draw a menu item.
    Private Sub FaceControlEditorDropdown_DrawItem(ByVal sender As Object, ByVal e As System.Windows.Forms.DrawItemEventArgs) Handles Me.DrawItem
        ' Draw the appropriate background.
        e.DrawBackground()

        ' Figure out how to center the image.
        Dim x As Integer = e.Bounds.X + ITEM_MARGIN
        Dim y As Integer = e.Bounds.Y + (e.Bounds.Height - 32) \ 2

        ' Draw the appropriate image.
        Select Case e.Index
            Case FaceControl.FaceStates.Happy
                e.Graphics.DrawImage(My.Resources.good_face, x, y)
            Case FaceControl.FaceStates.Neutral
                e.Graphics.DrawImage(My.Resources.neutral_face, x, y)
            Case FaceControl.FaceStates.Sad
                e.Graphics.DrawImage(My.Resources.bad_face, x, y)
            Case FaceControl.FaceStates.Painful
                e.Graphics.DrawImage(My.Resources.pain_face, x, y)
        End Select

        ' Draw the focus rectangle if appropriate.
        If e.State = DrawItemState.Selected Then e.DrawFocusRectangle()
    End Sub
End Class
