' Displays a dropdown editor for a color index.
Imports System.Drawing.Design

Public Class ColorIndexEditor
    Inherits System.Drawing.Design.UITypeEditor

    ' Indicates that this editor displays a dropdown.
    Public Overloads Overrides Function GetEditStyle(ByVal context As System.ComponentModel.ITypeDescriptorContext) As System.Drawing.Design.UITypeEditorEditStyle
        Return UITypeEditorEditStyle.DropDown
    End Function

    ' Edit a ColorIndex value.
    Public Overloads Overrides Function EditValue(ByVal context As System.ComponentModel.ITypeDescriptorContext, ByVal provider As System.IServiceProvider, ByVal value As Object) As Object
        ' Get an IWindowsFormsEditorService.
        Dim editor_service As IWindowsFormsEditorService = _
            CType(provider.GetService(GetType(IWindowsFormsEditorService)), _
                IWindowsFormsEditorService)

        ' If we failed to get the editor service, return the value.
        If editor_service Is Nothing Then Return value

        ' Convert the generic value into a ColorIndexes value.
        Dim color_index As ScribbleControl.LineColors = DirectCast(value, ScribbleControl.LineColors)

        ' Make the editing control.
        Dim editor_control As New ColorIndexListBox(color_index, editor_service)

        ' Display the editing control.
        editor_service.DropDownControl(editor_control)

        ' Convert the result from an Integer
        ' into a LineColors value and return it.
        Return CType(editor_control.SelectedIndex, ScribbleControl.LineColors)
    End Function
End Class
