Imports System.ComponentModel

<ToolboxItem(False)> _
Public Class LineWidthListBox
    Inherits ListBox

    ' The editor service displaying us.
    Private m_EditorService As IWindowsFormsEditorService

    ' A margin around the image in the list box.
    Private Const ITEM_MARGIN As Integer = 2

    Public Sub New(ByVal line_width As Integer, ByVal editor_service As IWindowsFormsEditorService)
        MyBase.New()
        m_EditorService = editor_service

        ' Give the list some items.
        For i As Integer = 0 To 9
            Me.Items.Add(i)
        Next i
        Me.SelectedIndex = line_width - 1
        Me.DrawMode = Windows.Forms.DrawMode.OwnerDrawFixed
        Me.ItemHeight = 16 + 2 * ITEM_MARGIN
    End Sub

    ' Close the dropdown.
    Private Sub LineWidthEditorDropdown_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Click
        If m_EditorService IsNot Nothing Then m_EditorService.CloseDropDown()
    End Sub

    ' Draw a menu item.
    Private Sub LineWidthEditorDropdown_DrawItem(ByVal sender As Object, ByVal e As System.Windows.Forms.DrawItemEventArgs) Handles Me.DrawItem
        ' Clear the background background.
        e.DrawBackground()

        ' Decide where to draw.
        Dim x1 As Integer = e.Bounds.X + ITEM_MARGIN
        Dim x2 As Integer = e.Bounds.Right - ITEM_MARGIN
        Dim y As Integer = e.Bounds.Y + e.Bounds.Height \ 2

        ' Draw the appropriate line.
        Using line_pen As New Pen(Color.Black, e.Index + 1)
            e.Graphics.DrawLine(line_pen, x1, y, x2, y)
        End Using

        ' Draw the focus rectangle if appropriate.
        If e.State = DrawItemState.Selected Then e.DrawFocusRectangle()
    End Sub
End Class
